diff --git a/src/winextras/qwinjumplist.cpp b/src/winextras/qwinjumplist.cpp
index 9caebdc..3662d25 100644
--- a/src/winextras/qwinjumplist.cpp
+++ b/src/winextras/qwinjumplist.cpp
@@ -112,19 +112,23 @@ QString QWinJumpListPrivate::iconsDirPath()
 
 void QWinJumpListPrivate::invalidate()
 {
+    qDebug() << __FUNCTION__ ;
     Q_Q(QWinJumpList);
     if (!pDestList)
         return;
 
     if (!dirty) {
         dirty = true;
+        qDebug() << __FUNCTION__  << "invokeMethod: _q_rebuild";
         QMetaObject::invokeMethod(q, "_q_rebuild", Qt::QueuedConnection);
     }
 }
 
 void QWinJumpListPrivate::_q_rebuild()
 {
+    qDebug() << __FUNCTION__ ;
     if (beginList()) {
+        qDebug() << __FUNCTION__ << "beginList";
         if (recent && recent->isVisible())
             appendKnownCategory(KDC_RECENT);
         if (frequent && frequent->isVisible())
@@ -135,7 +139,8 @@ void QWinJumpListPrivate::_q_rebuild()
         }
         if (tasks && tasks->isVisible())
             appendTasks(tasks->items());
-        commitList();
+        bool r = commitList();
+        qDebug() << __FUNCTION__ << "commitList" << r;
     }
     dirty = false;
 }
@@ -155,6 +160,7 @@ void QWinJumpListPrivate::destroy()
 
 bool QWinJumpListPrivate::beginList()
 {
+    qDebug() << __FUNCTION__;
     HRESULT hresult = S_OK;
     if (!identifier.isEmpty()) {
         wchar_t *id = qt_qstringToNullTerminated(identifier);
@@ -175,6 +181,7 @@ bool QWinJumpListPrivate::beginList()
 
 bool QWinJumpListPrivate::commitList()
 {
+    qDebug() << __FUNCTION__;
     HRESULT hresult = pDestList->CommitList();
     if (FAILED(hresult))
         QWinJumpListPrivate::warning("CommitList", hresult);
@@ -183,6 +190,7 @@ bool QWinJumpListPrivate::commitList()
 
 void QWinJumpListPrivate::appendKnownCategory(KNOWNDESTCATEGORY category)
 {
+    qDebug() << __FUNCTION__;
     HRESULT hresult = pDestList->AppendKnownCategory(category);
     if (FAILED(hresult))
         QWinJumpListPrivate::warning("AppendKnownCategory", hresult);
@@ -190,6 +198,7 @@ void QWinJumpListPrivate::appendKnownCategory(KNOWNDESTCATEGORY category)
 
 void QWinJumpListPrivate::appendCustomCategory(QWinJumpListCategory *category)
 {
+    qDebug() << __FUNCTION__;
     IObjectCollection *collection = toComCollection(category->items());
     if (collection) {
         wchar_t *title = qt_qstringToNullTerminated(category->title());
@@ -203,20 +212,24 @@ void QWinJumpListPrivate::appendCustomCategory(QWinJumpListCategory *category)
 
 void QWinJumpListPrivate::appendTasks(const QList<QWinJumpListItem *> &items)
 {
+    qDebug() << __FUNCTION__ << items;
     IObjectCollection *collection = toComCollection(items);
     if (collection) {
         HRESULT hresult = pDestList->AddUserTasks(collection);
         if (FAILED(hresult))
             QWinJumpListPrivate::warning("AddUserTasks", hresult);
         collection->Release();
+        qDebug() << __FUNCTION__ << "ok";
     }
 }
 
 QList<QWinJumpListItem *> QWinJumpListPrivate::fromComCollection(IObjectArray *array)
 {
+    qDebug() << __FUNCTION__;
     QList<QWinJumpListItem *> list;
     UINT count = 0;
     array->GetCount(&count);
+    qDebug() << __FUNCTION__ << "count = " << count ;
     for (UINT i = 0; i < count; ++i) {
         IUnknown *collectionItem = 0;
         HRESULT hresult = array->GetAt(i, qIID_IUnknown, reinterpret_cast<void **>(&collectionItem));
@@ -240,11 +253,13 @@ QList<QWinJumpListItem *> QWinJumpListPrivate::fromComCollection(IObjectArray *a
         if (jumplistItem)
             list.append(jumplistItem);
     }
+    qDebug() << __FUNCTION__ << list;
     return list;
 }
 
 IObjectCollection *QWinJumpListPrivate::toComCollection(const QList<QWinJumpListItem *> &list)
 {
+    qDebug() << __FUNCTION__ << list;
     if (list.isEmpty())
         return 0;
     IObjectCollection *collection = 0;
@@ -260,6 +275,7 @@ IObjectCollection *QWinJumpListPrivate::toComCollection(const QList<QWinJumpList
             iitem->Release();
         }
     }
+    qDebug() << __FUNCTION__ << collection;
     return collection;
 }
 
@@ -288,6 +304,7 @@ QWinJumpListItem *QWinJumpListPrivate::fromIShellLink(IShellLinkW *link)
     link->GetPath(buffer, buffersize-1, 0, 0);
     item->setFilePath(QDir::fromNativeSeparators(QString::fromWCharArray(buffer)));
 
+    qDebug() << __FUNCTION__ << link << "rets" << item;
     return item;
 }
 
@@ -298,11 +315,13 @@ QWinJumpListItem *QWinJumpListPrivate::fromIShellItem(IShellItem2 *shellitem)
     shellitem->GetDisplayName(SIGDN_FILESYSPATH, &strPtr);
     item->setFilePath(QDir::fromNativeSeparators(QString::fromWCharArray(strPtr)));
     CoTaskMemFree(strPtr);
+    qDebug() << __FUNCTION__ << shellitem << "rets" << item;
     return item;
 }
 
 IUnknown *QWinJumpListPrivate::toICustomDestinationListItem(const QWinJumpListItem *item)
 {
+    qDebug() << __FUNCTION__ << item;
     switch (item->type()) {
     case QWinJumpListItem::Destination :
         return toIShellItem(item);
@@ -317,6 +336,7 @@ IUnknown *QWinJumpListPrivate::toICustomDestinationListItem(const QWinJumpListIt
 
 IShellLinkW *QWinJumpListPrivate::toIShellLink(const QWinJumpListItem *item)
 {
+    qDebug() << __FUNCTION__ << item;
     IShellLinkW *link = 0;
     HRESULT hresult = CoCreateInstance(CLSID_ShellLink, 0, CLSCTX_INPROC_SERVER, qIID_IShellLinkW, reinterpret_cast<void **>(&link));
     if (FAILED(hresult)) {
@@ -370,17 +390,20 @@ IShellLinkW *QWinJumpListPrivate::toIShellLink(const QWinJumpListItem *item)
     PropVariantClear(&titlepv);
 
     delete[] buffer;
+    qDebug() << __FUNCTION__ << "rets" << link;
     return link;
 }
 
 IShellItem2 *QWinJumpListPrivate::toIShellItem(const QWinJumpListItem *item)
 {
+    qDebug() << __FUNCTION__ << item;
     IShellItem2 *shellitem = 0;
     qtShell32Dll.init();
     if (qtShell32Dll.sHCreateItemFromParsingName) {
         QScopedArrayPointer<wchar_t> buffer(qt_qstringToNullTerminated(item->filePath()));
         qtShell32Dll.sHCreateItemFromParsingName(buffer.data(), 0, qIID_IShellItem2, reinterpret_cast<void **>(&shellitem));
     }
+    qDebug() << __FUNCTION__ << "rets" << shellitem;
     return shellitem;
 }
 
@@ -460,6 +483,7 @@ QString QWinJumpList::identifier() const
 
 void QWinJumpList::setIdentifier(const QString &identifier)
 {
+    qDebug() << __FUNCTION__ << identifier;
     Q_D(QWinJumpList);
     QString id = identifier;
     id.replace(QLatin1Char(' '), QLatin1Char('_'));
@@ -481,6 +505,7 @@ QWinJumpListCategory *QWinJumpList::recent() const
         QWinJumpList *that = const_cast<QWinJumpList *>(this);
         that->d_func()->recent = QWinJumpListCategoryPrivate::create(QWinJumpListCategory::Recent, that);
     }
+    qDebug() << __FUNCTION__ << d->recent->count();
     return d->recent;
 }
 
@@ -494,6 +519,7 @@ QWinJumpListCategory *QWinJumpList::frequent() const
         QWinJumpList *that = const_cast<QWinJumpList *>(this);
         that->d_func()->frequent = QWinJumpListCategoryPrivate::create(QWinJumpListCategory::Frequent, that);
     }
+    qDebug() << __FUNCTION__ << d->frequent->count();
     return d->frequent;
 }
 
@@ -507,6 +533,7 @@ QWinJumpListCategory *QWinJumpList::tasks() const
         QWinJumpList *that = const_cast<QWinJumpList *>(this);
         that->d_func()->tasks = QWinJumpListCategoryPrivate::create(QWinJumpListCategory::Tasks, that);
     }
+    qDebug() << __FUNCTION__ << d->tasks->count();
     return d->tasks;
 }
 
@@ -527,6 +554,7 @@ void QWinJumpList::addCategory(QWinJumpListCategory *category)
     Q_D(QWinJumpList);
     if (!category)
         return;
+    qDebug() << __FUNCTION__ << category;
 
     QWinJumpListCategoryPrivate::get(category)->jumpList = this;
     d->categories.append(category);
@@ -540,6 +568,7 @@ void QWinJumpList::addCategory(QWinJumpListCategory *category)
  */
 QWinJumpListCategory *QWinJumpList::addCategory(const QString &title, const QList<QWinJumpListItem *> items)
 {
+    qDebug() << __FUNCTION__ << title << items;
     QWinJumpListCategory *category = new QWinJumpListCategory(title);
     foreach (QWinJumpListItem *item, items)
         category->addItem(item);
@@ -555,6 +584,7 @@ QWinJumpListCategory *QWinJumpList::addCategory(const QString &title, const QLis
 void QWinJumpList::clear()
 {
     Q_D(QWinJumpList);
+    qDebug() << __FUNCTION__ ;
     recent()->clear();
     frequent()->clear();
     if (d->tasks)
diff --git a/src/winextras/qwinjumplistcategory.cpp b/src/winextras/qwinjumplistcategory.cpp
index 2f26e1a..7c97249 100644
--- a/src/winextras/qwinjumplistcategory.cpp
+++ b/src/winextras/qwinjumplistcategory.cpp
@@ -89,12 +89,14 @@ QWinJumpListCategory *QWinJumpListCategoryPrivate::create(QWinJumpListCategory::
 
 void QWinJumpListCategoryPrivate::invalidate()
 {
+     qDebug() << __FUNCTION__ ;
     if (jumpList)
         QWinJumpListPrivate::get(jumpList)->invalidate();
 }
 
 void QWinJumpListCategoryPrivate::loadRecents()
 {
+    qDebug() << __FUNCTION__ ;
     Q_ASSERT(jumpList);
     IApplicationDocumentLists *pDocList = 0;
     HRESULT hresult = CoCreateInstance(qCLSID_ApplicationDocumentLists, 0, CLSCTX_INPROC_SERVER, qIID_IApplicationDocumentLists, reinterpret_cast<void **>(&pDocList));
@@ -104,6 +106,7 @@ void QWinJumpListCategoryPrivate::loadRecents()
             hresult = pDocList->SetAppID(id);
             delete[] id;
         }
+        qDebug() << __FUNCTION__ << jumpList->identifier() << SUCCEEDED(hresult);
         if (SUCCEEDED(hresult)) {
             IObjectArray *array = 0;
             hresult = pDocList->GetList(type == QWinJumpListCategory::Recent ? ADLT_RECENT : ADLT_FREQUENT,
@@ -121,6 +124,7 @@ void QWinJumpListCategoryPrivate::loadRecents()
 
 void QWinJumpListCategoryPrivate::addRecent(QWinJumpListItem *item)
 {
+     qDebug() << __FUNCTION__ ;
     Q_ASSERT(item->type() == QWinJumpListItem::Link);
     wchar_t *id = 0;
     if (jumpList && !jumpList->identifier().isEmpty())
@@ -138,6 +142,7 @@ void QWinJumpListCategoryPrivate::addRecent(QWinJumpListItem *item)
 
 void QWinJumpListCategoryPrivate::clearRecents()
 {
+     qDebug() << __FUNCTION__ ;
     IApplicationDestinations *pDest = 0;
     HRESULT hresult = CoCreateInstance(qCLSID_ApplicationDestinations, 0, CLSCTX_INPROC_SERVER, qIID_IApplicationDestinations, reinterpret_cast<void **>(&pDest));
     if (SUCCEEDED(hresult)) {