diff -Naur qtcreator/qtcreator.pri qtcreator-ICC/qtcreator.pri
--- qtcreator/qtcreator.pri	2016-04-22 07:47:41.573112000 -0700
+++ qtcreator-ICC/qtcreator.pri	2016-04-25 09:10:30.625870700 -0700
@@ -173,7 +173,7 @@
     UI_DIR = $${OUT_PWD}/.uic
 }
 
-win32-msvc* {
+msvc {
     #Don't warn about sprintf, fopen etc being 'unsafe'
     DEFINES += _CRT_SECURE_NO_WARNINGS
     QMAKE_CXXFLAGS_WARN_ON *= -w44996
diff -Naur qtcreator/src/libs/3rdparty/botan/botan.pri qtcreator-ICC/src/libs/3rdparty/botan/botan.pri
--- qtcreator/src/libs/3rdparty/botan/botan.pri	2016-04-22 07:47:41.743845300 -0700
+++ qtcreator-ICC/src/libs/3rdparty/botan/botan.pri	2016-04-25 09:10:30.628375900 -0700
@@ -34,7 +34,7 @@
         BOTAN_HAS_DYNAMIC_LOADER BOTAN_HAS_ENTROPY_SRC_CAPI BOTAN_HAS_ENTROPY_SRC_WIN32 \
         BOTAN_HAS_MUTEX_WIN32
 
-    win32-msvc* {
+    msvc {
         QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHs
         QMAKE_CXXFLAGS += -wd4251 -wd4290 -wd4250 -wd4297 -wd4267 -wd4334
         DEFINES += BOTAN_BUILD_COMPILER_IS_MSVC BOTAN_TARGET_OS_HAS_GMTIME_S _SCL_SECURE_NO_WARNINGS
diff -Naur qtcreator/src/libs/qtcreatorcdbext/cdb_detect.pri qtcreator-ICC/src/libs/qtcreatorcdbext/cdb_detect.pri
--- qtcreator/src/libs/qtcreatorcdbext/cdb_detect.pri	2016-03-26 10:12:52.727165100 -0700
+++ qtcreator-ICC/src/libs/qtcreatorcdbext/cdb_detect.pri	2016-04-25 09:10:30.630379500 -0700
@@ -2,7 +2,7 @@
 # in case MS VS compilers are used.
 
 CDB_PATH=""
-win32-msvc*|winrt {
+msvc|winrt {
     CDB_PATH="$$(CDB_PATH)"
     isEmpty(CDB_PATH):CDB_PATH="$$(ProgramFiles)/Debugging Tools For Windows/sdk"
     !exists($$CDB_PATH):CDB_PATH="$$(ProgramFiles)/Debugging Tools For Windows (x86)/sdk"
diff -Naur qtcreator/src/plugins/coreplugin/coreplugin.pro qtcreator-ICC/src/plugins/coreplugin/coreplugin.pro
--- qtcreator/src/plugins/coreplugin/coreplugin.pro	2016-03-26 10:12:58.251041000 -0700
+++ qtcreator-ICC/src/plugins/coreplugin/coreplugin.pro	2016-04-25 09:10:30.637894800 -0700
@@ -11,7 +11,7 @@
 !isEmpty(QTC_SHOW_BUILD_DATE): DEFINES += QTC_SHOW_BUILD_DATE
 
 include(../../qtcreatorplugin.pri)
-win32-msvc*:QMAKE_CXXFLAGS += -wd4251 -wd4290 -wd4250
+msvc:QMAKE_CXXFLAGS += -wd4251 -wd4290 -wd4250
 SOURCES += corejsextensions.cpp \
     mainwindow.cpp \
     shellcommand.cpp \
diff -Naur qtcreator/src/plugins/cpptools/cpptools.pro qtcreator-ICC/src/plugins/cpptools/cpptools.pro
--- qtcreator/src/plugins/cpptools/cpptools.pro	2016-03-26 10:13:01.154166100 -0700
+++ qtcreator-ICC/src/plugins/cpptools/cpptools.pro	2016-04-25 09:10:30.640399900 -0700
@@ -1,5 +1,5 @@
 DEFINES += CPPTOOLS_LIBRARY
-win32-msvc*:DEFINES += _SCL_SECURE_NO_WARNINGS
+msvc:DEFINES += _SCL_SECURE_NO_WARNINGS
 include(../../qtcreatorplugin.pri)
 
 HEADERS += \
diff -Naur qtcreator/src/plugins/debugger/shared/shared.pri qtcreator-ICC/src/plugins/debugger/shared/shared.pri
--- qtcreator/src/plugins/debugger/shared/shared.pri	2016-03-26 10:13:03.585873200 -0700
+++ qtcreator-ICC/src/plugins/debugger/shared/shared.pri	2016-04-25 09:10:30.632884600 -0700
@@ -10,7 +10,7 @@
            $$PWD/peutils.h \
     shared/symbolpathsdialog.h
 
-win32-msvc* {
+msvc {
 #   For the Privilege manipulation functions in sharedlibraryinjector.cpp.
     LIBS += -ladvapi32
 }
diff -Naur qtcreator/src/shared/clang/clang_installation.pri qtcreator-ICC/src/shared/clang/clang_installation.pri
--- qtcreator/src/shared/clang/clang_installation.pri	2016-03-26 10:13:14.120058700 -0700
+++ qtcreator-ICC/src/shared/clang/clang_installation.pri	2016-04-25 09:10:30.635390000 -0700
@@ -53,7 +53,7 @@
 
 defineReplace(findClangOnWindows) {
     FILE_EXTS = a dll
-    win32-msvc*: FILE_EXTS = lib dll
+    msvc: FILE_EXTS = lib dll
     for (suffix, $$list(lib bin)) {
         for (libname, $$list(clang libclang)) {
             for (ext, FILE_EXTS) {
diff -Naur qtcreator/src/tools/wininterrupt/wininterrupt.pro qtcreator-ICC/src/tools/wininterrupt/wininterrupt.pro
--- qtcreator/src/tools/wininterrupt/wininterrupt.pro	2016-03-26 10:13:15.066793500 -0700
+++ qtcreator-ICC/src/tools/wininterrupt/wininterrupt.pro	2016-04-25 09:10:30.642905300 -0700
@@ -7,7 +7,7 @@
 # global state of the CRT, reconsider if other DLLs are required!
 # TODO: No effect, currently?
 
-win32-msvc* {
+msvc {
     QMAKE_CXXFLAGS_RELEASE    -= -MD
     QMAKE_CXXFLAGS_DEBUG      -= -MDd
     QMAKE_CXXFLAGS_RELEASE    += -MT
diff -Naur qtcreator/tests/auto/debugger/dumpers.pro qtcreator-ICC/tests/auto/debugger/dumpers.pro
--- qtcreator/tests/auto/debugger/dumpers.pro	2016-03-26 10:13:15.600405300 -0700
+++ qtcreator-ICC/tests/auto/debugger/dumpers.pro	2016-04-25 09:10:30.645911600 -0700
@@ -4,7 +4,7 @@
 
 include(../qttest.pri)
 
-win32-msvc* {
+msvc {
     LIBS *= -L$$IDE_PLUGIN_PATH
     DEFINES += Q_PLUGIN_PATH=\"\\\"$$IDE_PLUGIN_PATH\\\"\"
 
diff -Naur qtcreator/tests/auto/valgrind/memcheck/testapps/leak2/leak2.pro qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/leak2/leak2.pro
--- qtcreator/tests/auto/valgrind/memcheck/testapps/leak2/leak2.pro	2016-03-26 10:13:17.364396300 -0700
+++ qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/leak2/leak2.pro	2016-04-25 09:10:30.649418700 -0700
@@ -3,7 +3,7 @@
 
 CONFIG += debug
 
-win32-msvc*:QMAKE_CXXFLAGS += -w44996
+msvc:QMAKE_CXXFLAGS += -w44996
 QT += core
 
 macx:CONFIG -= app_bundle
diff -Naur qtcreator/tests/auto/valgrind/memcheck/testapps/leak3/leak3.pro qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/leak3/leak3.pro
--- qtcreator/tests/auto/valgrind/memcheck/testapps/leak3/leak3.pro	2016-03-26 10:13:17.372415000 -0700
+++ qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/leak3/leak3.pro	2016-04-25 09:10:30.651923800 -0700
@@ -7,6 +7,6 @@
 
 macx:CONFIG -= app_bundle
 
-win32-msvc*:QMAKE_CXXFLAGS += -w44996
+msvc:QMAKE_CXXFLAGS += -w44996
 
 SOURCES += main.cpp
diff -Naur qtcreator/tests/auto/valgrind/memcheck/testapps/overlap/overlap.pro qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/overlap/overlap.pro
--- qtcreator/tests/auto/valgrind/memcheck/testapps/overlap/overlap.pro	2016-03-26 10:13:17.388150600 -0700
+++ qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/overlap/overlap.pro	2016-04-25 09:10:30.654929700 -0700
@@ -3,7 +3,7 @@
 
 CONFIG += debug console
 CONFIG -= qt
-!win32-msvc*:QMAKE_CXXFLAGS = -O0 -fno-builtin
+!msvc:QMAKE_CXXFLAGS = -O0 -fno-builtin
 
 macx:CONFIG -= app_bundle
 
diff -Naur qtcreator/tests/auto/valgrind/memcheck/testapps/syscall/syscall.pro qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/syscall/syscall.pro
--- qtcreator/tests/auto/valgrind/memcheck/testapps/syscall/syscall.pro	2016-03-26 10:13:17.394170400 -0700
+++ qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/syscall/syscall.pro	2016-04-25 09:10:30.657935900 -0700
@@ -2,7 +2,7 @@
 TARGET = syscall
 
 CONFIG += debug
-win32-msvc*:QMAKE_CXXFLAGS += -w44700
+msvc:QMAKE_CXXFLAGS += -w44700
 else:QMAKE_CXXFLAGS = -O0 -Wno-uninitialized
 
 QT += core
diff -Naur qtcreator/tests/auto/valgrind/memcheck/testapps/uninit1/uninit1.pro qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/uninit1/uninit1.pro
--- qtcreator/tests/auto/valgrind/memcheck/testapps/uninit1/uninit1.pro	2016-03-26 10:13:17.407452100 -0700
+++ qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/uninit1/uninit1.pro	2016-04-25 09:10:30.660942200 -0700
@@ -3,7 +3,7 @@
 
 CONFIG += debug console
 CONFIG -= qt
-win32-msvc*:QMAKE_CXXFLAGS += -w44700
+msvc:QMAKE_CXXFLAGS += -w44700
 else:QMAKE_CXXFLAGS = -O0 -Wno-uninitialized
 
 macx:CONFIG -= app_bundle
diff -Naur qtcreator/tests/auto/valgrind/memcheck/testapps/uninit2/uninit2.pro qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/uninit2/uninit2.pro
--- qtcreator/tests/auto/valgrind/memcheck/testapps/uninit2/uninit2.pro	2016-03-26 10:13:17.414454500 -0700
+++ qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/uninit2/uninit2.pro	2016-04-25 09:10:30.663948100 -0700
@@ -3,7 +3,7 @@
 
 CONFIG += debug console
 CONFIG -= qt
-win32-msvc*:QMAKE_CXXFLAGS += -w44700
+msvc:QMAKE_CXXFLAGS += -w44700
 else:QMAKE_CXXFLAGS = -O0 -Wno-uninitialized
 
 macx:CONFIG -= app_bundle
diff -Naur qtcreator/tests/auto/valgrind/memcheck/testapps/uninit3/uninit3.pro qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/uninit3/uninit3.pro
--- qtcreator/tests/auto/valgrind/memcheck/testapps/uninit3/uninit3.pro	2016-03-26 10:13:17.420435300 -0700
+++ qtcreator-ICC/tests/auto/valgrind/memcheck/testapps/uninit3/uninit3.pro	2016-04-25 09:10:30.666453200 -0700
@@ -3,7 +3,7 @@
 
 CONFIG += debug console
 CONFIG -= qt
-win32-msvc*:QMAKE_CXXFLAGS += -w44700
+msvc:QMAKE_CXXFLAGS += -w44700
 else:QMAKE_CXXFLAGS = -O0 -Wno-uninitialized
 
 macx:CONFIG -= app_bundle
diff -Naur qtcreator/tests/manual/debugger/simple/simple_test_app.pro qtcreator-ICC/tests/manual/debugger/simple/simple_test_app.pro
--- qtcreator/tests/manual/debugger/simple/simple_test_app.pro	2016-03-26 10:13:17.759107300 -0700
+++ qtcreator-ICC/tests/manual/debugger/simple/simple_test_app.pro	2016-04-25 09:10:30.669459800 -0700
@@ -64,7 +64,7 @@
     INCLUDEPATH += /usr/local/include/eigen3
 }
 
-win32-msvc*:DEFINES += _CRT_SECURE_NO_WARNINGS
+msvc:DEFINES += _CRT_SECURE_NO_WARNINGS
 # Use for semi-automated testing
 #DEFINES += USE_AUTORUN=1
 
diff -Naur qtcreator/tests/unit/unittest/unittest.pro qtcreator-ICC/tests/unit/unittest/unittest.pro
--- qtcreator/tests/unit/unittest/unittest.pro	2016-04-22 07:47:43.796636100 -0700
+++ qtcreator-ICC/tests/unit/unittest/unittest.pro	2016-04-25 09:10:30.672967200 -0700
@@ -20,7 +20,7 @@
     UNIT_TESTS \
     DONT_CHECK_MESSAGE_COUNTER \
     TESTDATA_DIR=\"R\\\"xxx($$PWD/data)xxx\\\"\"
-win32-msvc*:QMAKE_CXXFLAGS_WARN_ON -= -w34100 # 'unreferenced formal parameter' in MATCHER_* functions
+msvc:QMAKE_CXXFLAGS_WARN_ON -= -w34100 # 'unreferenced formal parameter' in MATCHER_* functions
 win32:DEFINES += ECHOSERVER=\"R\\\"xxx($$OUT_PWD/../echo)xxx\\\"\"
 unix: DEFINES += ECHOSERVER=\"R\\\"xxx($$OUT_PWD/../echoserver/echo)xxx\\\"\"
 